# include "hbdisplay.h"
# include "mainwindow.h"
# include <QtGui>

MainWindow :: MainWindow ( QWidget * parent ) : QWidget ( parent )
{
	QLabel * fileNameLabel = new QLabel ( "&Filename :" ) ;

	fileNameTextEdit = new QPlainTextEdit ; // privatevar
	fileNameTextEdit -> setMaximumHeight ( 30 ) ;
	fileNameTextEdit -> setHorizontalScrollBarPolicy ( Qt :: ScrollBarAlwaysOff ) ;
	fileNameTextEdit -> setVerticalScrollBarPolicy ( Qt :: ScrollBarAlwaysOff ) ;
	fileNameTextEdit -> setLineWrapMode ( QPlainTextEdit :: NoWrap ) ;
	fileNameLabel -> setBuddy ( fileNameTextEdit ) ;

	QPushButton * fileNameButton = new QPushButton ( "&Browse..." ) ;

	QLabel * sizeLabel = new QLabel ( "&Size :" ) ;

	sizeSpin = new QSpinBox ; // privatevar
	sizeSpin -> setMinimum ( 10 ) ;
	sizeSpin -> setMaximum ( 144 ) ;
	sizeSpin -> setValue ( 20 ) ;
	sizeLabel -> setBuddy ( sizeSpin ) ;

	inputText = new QPlainTextEdit ; // privatevar
	hbdisplay = new HBDisplay ; // privatevar
	QPushButton * renderButton = new QPushButton ( "&RENDER" ) ;

	QHBoxLayout * topLayout = new QHBoxLayout ;
	topLayout -> addWidget ( fileNameLabel ) ;
	topLayout -> addWidget ( fileNameTextEdit ) ;
	topLayout -> addWidget ( fileNameButton ) ;
	topLayout -> addWidget ( sizeLabel ) ;
	topLayout -> addWidget ( sizeSpin ) ;

	QVBoxLayout * mainLayout = new QVBoxLayout ;
	mainLayout -> addLayout ( topLayout ) ;
	mainLayout -> addWidget ( inputText ) ;
	mainLayout -> addWidget ( hbdisplay ) ;
	mainLayout -> addWidget ( renderButton ) ;

 	connect ( fileNameButton, SIGNAL ( clicked () ), this, SLOT ( getFileName () ) ) ;
	connect ( renderButton, SIGNAL ( clicked () ), this, SLOT ( renderText () ) ) ;

	setLayout ( mainLayout ) ;
}

void MainWindow :: getFileName ( void )
{
	QString newFileName = QFileDialog :: getOpenFileName ( this, "Select Font File", QDir :: homePath () , "TrueType font files (*.ttf)" ) ;
	if ( not newFileName . isNull () ) fileNameTextEdit -> setPlainText ( newFileName ) ;
}

void MainWindow :: renderText ( void )
{
	hbdisplay -> fileName = fileNameTextEdit -> toPlainText () ;
	hbdisplay -> text = inputText -> toPlainText () ;
	hbdisplay -> fontSize = sizeSpin -> value () ;
	hbdisplay -> repaint () ;
}
